/*

diag.h - Diagnostic code

*/

#ifndef DIAG_H
#define	DIAG_H

/*...sincludes:0:*/
#include <stdlib.h>
#include <stdarg.h>

#include "types.h"

/*...vtypes\46\h:0:*/
/*...e*/

#define	DIAGM_CONSOLE               0x00000001
#define	DIAGM_FILE                  0x00000002
#define	DIAGM_RING                  0x00000004

#define	DIAG_ALWAYS                   0
#define	DIAG_WIN_UNKNOWN_KEY          1
#define	DIAG_MEM_IOBYTE               2
#define	DIAG_MEM_DUMP                 3
#define	DIAG_VID_STATUS               4
#define	DIAG_VID_REGISTERS            5
#define	DIAG_VID_ADDRESS              6
#define	DIAG_VID_DATA                 7
#define	DIAG_VID_REFRESH              8
#define	DIAG_VID_MARKERS              9
#define	DIAG_KBD_WIN_KEY             10
#define	DIAG_KBD_SENSE               11
#define	DIAG_KBD_REMAP               12
#define	DIAG_SND_REGISTERS           13
#define	DIAG_SND_LATENCY             14
#define	DIAG_CTC_REGISTERS           15
#define	DIAG_CTC_PENDING             16
#define	DIAG_CTC_INTERRUPT           17
#define	DIAG_MON_HW                  18
#define	DIAG_MON_KBD_WIN_KEY         19
#define	DIAG_MON_KBD_MAP_TH          20
#define	DIAG_SDXFDC_PORT             21
#define	DIAG_SDXFDC_HW               22
#define	DIAG_SDXFDC_DATA             23
#define	DIAG_SDXFDC_STATUS           24
#define	DIAG_SIDISC_FILE             25
#define	DIAG_SIDISC_ADDRESS          26
#define	DIAG_SIDISC_DATA             27
#define	DIAG_PRINT                   28
#define	DIAG_CPM_DRIVER              29
#define	DIAG_CPM_CBIOS               30
#define	DIAG_CPM_BDOS_FILE           31
#define	DIAG_CPM_BDOS_OTHER          32
#define	DIAG_Z80_INSTRUCTIONS        33
#define	DIAG_Z80_INSTRUCTIONS_NEW    34
#define	DIAG_Z80_INTERRUPTS          35
#define	DIAG_BAD_PORT                36
#define	DIAG_PANEL_HACK              37
#define	DIAG_TAPE                    38
#define	DIAG_SPEED                   39
#define	DIAG_EXIT                    40
#define DIAG_HW_WIN                  41
#define DIAG_HW_KBD                  42
#define	DIAG_COUNT                   43  /* Must be last entry and largest value */

extern unsigned int diag_methods;

extern unsigned int diag_method_of(const char *s);

extern BOOLEAN diag_flags[DIAG_COUNT];

extern BOOLEAN diag_flag_of(const char *s);

extern void diag_message(unsigned int flag, const char *fmt, ...);

extern void diag_init(void);

extern void diag_term(void);

#endif
